/**********************************/
/* X^[LN^ύX */
/**********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	96
#define	MAXHEIGHT	1200

void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);
int main(int argc, char **argv)
{
	FILE	*infp, *outfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];
	int		c_pixel[MAXWIDTH/2][MAXHEIGHT];

	int		width,height;
	int		x,y;
	int		m,n,i,j,k;
	int		a0,a1,a2,a3,c;
	int		a4,a5,a6,a7;
	int		sft;
	int		characnt;


	if (argc != 4) {
		fprintf(stderr, "Usage: convchara inputfile outputfile characnt\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	characnt = atoi(argv[3]);

	height = 1200;
	width  = 96;

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	for (n = 0;n < characnt;n ++) {
		for (m = 0;m < 5;m ++) {
			for (k = 0;k < 6;k ++) {

				for (y = 0;y < 8;y ++) {

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+0+x][n*40+m*8+y] |= 0x01;
						}
						sft /= 2;
					}

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+8+x][n*40+m*8+y] |= 0x01;
						}
						sft /= 2;
					}

				}

				for (y = 0;y < 8;y ++) {

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+0+x][n*40+m*8+y] |= 0x02;
						}
						sft /= 2;
					}

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+8+x][n*40+m*8+y] |= 0x02;
						}
						sft /= 2;
					}

				}

				for (y = 0;y < 8;y ++) {

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+0+x][n*40+m*8+y] |= 0x04;
						}
						sft /= 2;
					}

					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ((sft & c) != 0) {
							pixel[k*16+8+x][n*40+m*8+y] |= 0x04;
						}
						sft /= 2;
					}


				}

			}
		}

		for (i = 0;i < 0x600-0x5a0;i ++) {
			fgetc(infp);
		}

	}


/* Fϊ */
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			switch (pixel[x][y]) {
				case 0x08:	/*  */
					pixel[x][y] = 0x08;	/*  */
					break;
				case 0x09:	/* ipbgŕϊĂj */
					pixel[x][y] = 0x0a;	/*  */
					break;
				case 0x0a:	/*  */
					pixel[x][y] = 0x09;	/*  */
					break;
				case 0x0b:	/*  */
					pixel[x][y] = 0x0b;	/*  */
					break;
				case 0x0c:	/*  */
					pixel[x][y] = 0x0a;	/*  */
					break;
				case 0x0d:	/* F */
					pixel[x][y] = 0x0a;	/*  */
					break;
				case 0x0e:	/*  */
					pixel[x][y] = 0x09;	/*  */
					break;
				case 0x0f:	/* ipbgŕϊĂj */
					pixel[x][y] = 0x0b;	/*  */
					break;
				default:
					pixel[x][y] = 0x08;	/*  */
					break;
			}
		}
	}

	convpic(width,height,c_pixel,pixel);


/* f[^o */
	for (n = 0;n < characnt;n ++) {

		for (m = 0;m < 5;m ++) {
			for (k = 0;k < 6;k ++) {
				for (y = 0;y < 8;y ++) {

					a0 = c_pixel[k*8+0][n*40+m*8+y];
					a1 = c_pixel[k*8+1][n*40+m*8+y];
					a2 = c_pixel[k*8+2][n*40+m*8+y];
					a3 = c_pixel[k*8+3][n*40+m*8+y];
					a4 = c_pixel[k*8+4][n*40+m*8+y];
					a5 = c_pixel[k*8+5][n*40+m*8+y];
					a6 = c_pixel[k*8+6][n*40+m*8+y];
					a7 = c_pixel[k*8+7][n*40+m*8+y];

					c =
						( ((a0 & 0x01) == 0x00) ? 0x00 : 0x80 ) +
						( ((a1 & 0x01) == 0x00) ? 0x00 : 0x40 ) +
						( ((a2 & 0x01) == 0x00) ? 0x00 : 0x20 ) +
						( ((a3 & 0x01) == 0x00) ? 0x00 : 0x10 ) +
						( ((a4 & 0x01) == 0x00) ? 0x00 : 0x08 ) +
						( ((a5 & 0x01) == 0x00) ? 0x00 : 0x04 ) +
						( ((a6 & 0x01) == 0x00) ? 0x00 : 0x02 ) +
						( ((a7 & 0x01) == 0x00) ? 0x00 : 0x01 );

					fputc(c,outfp);
				}

				for (y = 0;y < 8;y ++) {

					a0 = c_pixel[k*8+0][n*40+m*8+y];
					a1 = c_pixel[k*8+1][n*40+m*8+y];
					a2 = c_pixel[k*8+2][n*40+m*8+y];
					a3 = c_pixel[k*8+3][n*40+m*8+y];
					a4 = c_pixel[k*8+4][n*40+m*8+y];
					a5 = c_pixel[k*8+5][n*40+m*8+y];
					a6 = c_pixel[k*8+6][n*40+m*8+y];
					a7 = c_pixel[k*8+7][n*40+m*8+y];

					c =
						( ((a0 & 0x02) == 0x00) ? 0x00 : 0x80 ) +
						( ((a1 & 0x02) == 0x00) ? 0x00 : 0x40 ) +
						( ((a2 & 0x02) == 0x00) ? 0x00 : 0x20 ) +
						( ((a3 & 0x02) == 0x00) ? 0x00 : 0x10 ) +
						( ((a4 & 0x02) == 0x00) ? 0x00 : 0x08 ) +
						( ((a5 & 0x02) == 0x00) ? 0x00 : 0x04 ) +
						( ((a6 & 0x02) == 0x00) ? 0x00 : 0x02 ) +
						( ((a7 & 0x02) == 0x00) ? 0x00 : 0x01 );

					fputc(c,outfp);

				}
				for (i = 0;i < 32;i ++) {
					fputc(0x00,outfp);
				}
			}
		}

		for (i = 0;i < 0x600-0x5a0;i ++) {
			fputc(0x00,outfp);
		}

	}

	fclose(infp);
	fclose(outfp);

	return(0);

}


void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{

	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	return;
}

